<template lang="pug">
b-card( title="Рассылки" )
	template( #icon )
		router-link.button.is-small.is-primary.has-text-weight-bold( :to='{ name: "AddCampagin" }' ) Добавить
	b-table( :columns='columns' :data='campagins' :loading='pending' )
		template( #status='{ item }' )
			.tag.is-flex-inline( :class='itemClass(item)' ) {{ campaginStatus(item.status).text }}
		template( #group='{ item }' )
			router-link.tag.is-primary.is-light( v-if='item.group' :to='{ name: "Group", params: { id: item.group.id } }' ) {{ item.group.name }}
			p.has-text-grey( v-else ) Группа удалена
		template( #buttons='{ item }' )
			.buttons.are-small
				.button.is-danger( v-if='item.status == "created"' @click='remove(item.id)' )
					span.icon.is-small
						i.fa-solid.fa-trash-can
				router-link.button.is-link( :to='{ name: "Campagin", params: { id: item.id } }' )
					span.icon.is-small
						i.fa-solid.fa-arrow-right
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BPagination from "@/components/table/Pagination.vue"

import { useCampaginStore } from "@/stores/campagin"
import { computed, onMounted, ref } from "vue"
import parseCamplaginStatus from "@/common/campaginStatus"
import { useSocket } from "@/stores/socket"

const columns = [
	{
		label: "ID",
		field: "id"
	},
	{
		label: "Статус",
		field: "status"
	},
	{
		label: "Группа",
		field: "group"
	},
	{
		field: "buttons"
	}
]

const cs = useCampaginStore()
const io = useSocket()

const pending = ref(false)

const campagins = computed(() => cs.campagins)

const campaginStatus = parseCamplaginStatus
const itemClass = item => [
	{ "loading": item.status == "pending" }, 
	`is-${campaginStatus(item.status).type}`
]
const remove = async id => {
	await cs.removeCampagin(id)
	fetch()
}
const fetch = async () => {
	pending.value = true
	try {
		await cs.getCampagins()
	} catch(err) {
		console.error(err)
	}
	pending.value = false
}

onMounted(() => {
	fetch()

	io.on("update_campagins", fetch)
})
</script>

<style lang="scss" scoped>
.table-wrapper:deep(td.status) {
	width: 10rem;
}

.tag.loading {
	&::after {
		display: block;
		content: ".";
		animation: dots 1.5s infinite;
	}
}

@keyframes dots {
	0%, 10% { content: "." }
	50% { content: ".." }
	90% { content: "..." }
}
</style>